//*****************************************************************************************
//  
//*****************************************************************************************
var _mg_keys_pressed = new Array();
for (var i = 0; i <= 255; i++) { _mg_keys_pressed[i] = false; };



//    
function TMGSprite() {
 var self = this;
 this.initialize = function( filepath, framescount) {
  this.img = new Image();
  this.img.src = filepath;
  this.img.onload = function() { /*alert(1);*/ }
  this.frames = framescount;
 }
 this.draw = function( ctx, x, y) {
  ctx.drawImage( self.img, x, y);
 }
 this.drawStretch = function( ctx, x, y, w, h) {
  ctx.drawImage( this.img, Math.round(x), Math.round(y), w, h);
 }
 this.drawRect = function( ctx, sx, sy, sw, sh, px, py, pw, ph) {
  ctx.drawImage( this.img, sx, sy, sw, sh, px, py, pw, ph);
 }
}

//    
function TMGObject() {
  var self = this;
  this.initialize = function() {
   this.codeDraw = function(ctx) { this.sprite.drawStretch( ctx, this.x, this.y, this.width, this.height); }
   this.codeStep = function() {  }
   this.sprite;
   this.id = 0;
   this.curframe = 0;
   this.x = 0;
   this.y = 0;
   this.width = 0;
   this.height = 0;
   this.interval = 47;
   this.visible = true;
  }
  this.setSprite = function(spr) {
   this.sprite = spr;
   this.width = spr.img.width;
   this.height = spr.img.height;
  }
  this.draw = function(ctx) {
   if (this.visible == true) {
    if ((this.width > 0)&&(this.height > 0)) {
	 this.codeDraw(ctx);
	}
   }
  }
  this.step = function(ft) {
   this.codeStep(ft);
  }
}

    window.requestAnimFrame = (function(){
      return  window.requestAnimationFrame       || 
              window.webkitRequestAnimationFrame || 
              window.mozRequestAnimationFrame    || 
              window.oRequestAnimationFrame      || 
              window.msRequestAnimationFrame     || 
              function( callback, element){ window.setTimeout(callback, 1000 / 60); };
    })();




//   
function getClientWidth() { return document.compatMode=='CSS1Compat' && !window.opera?document.documentElement.clientWidth:document.body.clientWidth; }
function getClientHeight() { return document.compatMode=='CSS1Compat' && !window.opera?document.documentElement.clientHeight:document.body.clientHeight; }



function __keydownlistener__ (_mgp_e) {
  var _mgv_key = _mgp_e.keyCode;
  _mg_keys_pressed[_mgv_key] = true;
};
	
function __keyuplistener__ (_mgp_e) {
  var _mgv_key = _mgp_e.keyCode;
  _mg_keys_pressed[_mgv_key] = false;
};

	
function __mousedownlistener__ ( _e ) {
	/*if ( __mousestatus__ == 0 ) __mousepressed__ = 1;
	__mousestatus__ = 1;*/
};
	
function __mouseuplistener__ ( _e ) {
	/*if ( __mousestatus__ == 1 ) __mousereleased__ = 1;
	__mousestatus__ = 0;*/
};

function __mousemovelistener__(e){
  var x = 0, y = 0;
  if (!e) e = window.event;
  if (e.pageX || e.pageY)
  { x = e.pageX; y = e.pageY; }
  else if (e.clientX || e.clientY)
  {
    x = e.clientX + (document.documentElement.scrollLeft || document.body.scrollLeft) - document.documentElement.clientLeft;
    y = e.clientY + (document.documentElement.scrollTop || document.body.scrollTop) - document.documentElement.clientTop;
  }
  //x -= game._cnv.offsetLeft + 1;
  //y -= game._cnv.offsetTop + 1;
  return {"x":x, "y":y};
 }



//   
	if ( document.addEventListener ) {
		document.addEventListener( "keydown", __keydownlistener__, false );
		document.addEventListener( "keyup", __keyuplistener__, false );
		document.addEventListener( "mousemove", __mousemovelistener__, false );
		document.addEventListener( "mousedown", __mousedownlistener__, false );
		document.addEventListener( "mouseup", __mouseuplistener__, false );
	} else {
		document.attachEvent( "onkeydown", __keydownlistener__ );
		document.attachEvent( "onkeyup", __keyuplistener__ );
		document.attachEvent( "onmousemove", __mousemovelistener__ );
		document.attachEvent( "onmousedown", __mousedownlistener__ );
		document.attachEvent( "onmouseup", __mouseuplistener__ );
		
	}







var spr1 = new TMGSprite();
spr1.initialize('test.bmp', 0);

var obj1 = new TMGObject();


var cnv11 = document.getElementById('Dynamic');
var ctx11 = cnv11.getContext('2d');
ctx11.clearRect(0,0, 640,480);
ctx11.fillText(self._fps, 10, 50);


function Engine() {
 var self = this;
      
  this.initialize = function() {
     this._cnv = document.getElementById('ForeGround');
     this._ctx = this._cnv.getContext('2d');
	 
    //  
     this.m_canvas = document.createElement('canvas');
     this.m_canvas.width = self._cnv.width;
     this.m_canvas.height = self._cnv.height;
     this.m_context = self.m_canvas.getContext('2d');
	 
    //this.m_context.fillStyle = 'rgb(200,200,200)';
    //this.m_context.fillRect(0,0, this.m_canvas.width,this.m_canvas.height);
    //this._ctx.clearRect(0,0, 640,480);
	 
    this._fps = 0;
    this._fpsclick = 0;

    //  
    this._mg_lasttime = 0;
    this._mg_starttime = new Date().getTime(); 
    this._mg_time = new Date().getTime() - this._mg_starttime;
    this._mg_frametime = 0;

    setInterval( function() { self._fps = self._fpsclick; self._fpsclick = 0; }, 1000);
    //setInterval( function() { self.loop(); }, 1000 / 60);
    self.loop();

  }

  this.loop = function() {

	//this._ctx.fillStyle = "rgba(255, 0, 0, 0.0)";
    //this._ctx.clearRect(0,0, 640,480);
	//this._ctx.fillRect(0,0, 640,480); 
	
	//ctx11.fillStyle = "blue";
	//ctx11.fillRect(0,0, 640,480); 
	//ctx11.fillText(self._fps, 10, 50);
	
    for (var i = 0; i <= 255; i++) {
		obj1.step(this._mg_frametime);
		obj1.draw(this._ctx);
	}

    this._ctx.fillText(obj1.y, 10, 10);
    this._ctx.fillText(self._mg_time, 10, 30); 
    this._ctx.fillText(self._fps, 10, 50);

   //  ,    
   this._mg_lasttime = this._mg_time;
   this._mg_time = new Date().getTime() - this._mg_starttime;
   this._mg_frametime = this._mg_time - this._mg_lasttime;
   //    
   this._fpsclick+=1;  
   //    
   requestAnimFrame( function() { self.loop(); });
   //this.loop();
  }
  
};

 
Function.prototype.bind = function(bind) {
  var me = this;
  return function() {
    var args = Array.prototype.slice.call(arguments);
    return me.apply(bind || null, args);
  };
};



function BeginEngine() {

var game = new Engine();

window.addEventListener("load",function() {
	 
	 

    obj1.initialize();
    obj1.setSprite(spr1);
    obj1.codeStep = function(ft) {
  /*if (_mg_keys_pressed[37] == true) this.x-=ft * (10 / 60);
  if (_mg_keys_pressed[38] == true) this.y-=ft * (10 / 60);
  if (_mg_keys_pressed[39] == true) this.x+=ft * (10 / 60);
  if (_mg_keys_pressed[40] == true) this.y+=ft * (10 / 60);*/
  if (_mg_keys_pressed[37] == true) this.x-=3;
  if (_mg_keys_pressed[38] == true) this.y-=3;
  if (_mg_keys_pressed[39] == true) this.x+=3;
  if (_mg_keys_pressed[40] == true) this.y+=3;
     }
	
    game.initialize();
	
  }, false);
  
  }