// Make-Games.ru [Constructor, ]
// Ver 0.0.1

function LoadFileFromURL(_mge_url, _mge_load_proc, _mge_parameter_proc) { //_mge_load_proc(_mge_parameter_proc, _mge_file_byte_data);
	var _file = new XMLHttpRequest();
	_file.open("GET", url, true);
	_file.responseType = "arraybuffer";
	_file.onload = function(_mge_event) {
		_mge_load_proc(_mge_parameter_proc, _mge_event.target.response);
	}
	_file.send();
}

window.RequestAnimFrame = (function(){
	return window.requestAnimationFrame   || 
		window.webkitRequestAnimationFrame || 
		window.mozRequestAnimationFrame    || 
		window.oRequestAnimationFrame      || 
		window.msRequestAnimationFrame     || 
		function(callback, element){ window.setTimeout(callback, 16); };
})();

/*window.RequestAnimFrame = (function(){ // for debug mode
	return function(callback, element){ window.setTimeout(callback, 1000); };
})();*/

//For CocoonJS window.setTimeout(callback, 16);

//**
function MGECore() {
	var Self = this;
	
	//**
	Self.IsLoop = true;
	
	//**
	Self.FPS = 0;
	Self.CurFPS = 0;
	Self.FPSTimer = 0;
	
	//**
	Self.CurTime = 0;
	Self.StepTime = 0;
	Self.FrameTime = 0;
	Self.StartTime = 0;
	Self.GlobalTime = 0;
	
	//**
	Self.FullScreen = false;
	
	//**
	Self.Step = function () {  }
	
	//**
	Self.BeginLoop = function () {
		var _cur_time = new Date();
		Self.GlobalTime = _cur_time.getTime();
		Self.StartTime = Self.GlobalTime;
		//**
		Self.FPS = 0;
		Self.CurFPS = 0;
		Self.FPSTimer = 0;
		Self.CurTime = 0;
		Self.StepTime = 0;
		Self.FrameTime = 0;
		//**
		if (Self.IsLoop === true) {
			Self.Loop();
		}
	}

	Self.Loop = function () {
		//**
		if (Self.IsLoop === false) { return; }
		var _cur_time = new Date();
		_cur_time = _cur_time.getTime();
		//**
		Self.FrameTime = _cur_time - Self.GlobalTime;
		Self.GlobalTime = _cur_time;
		Self.CurTime = Self.GlobalTime - Self.StartTime;
		//**
		Self.CurFPS += 1;
		Self.FPSTimer += Self.FrameTime;
		if (Self.FPSTimer >= 998) { // 998 for correct fps math, because 1000 / 60 = 16,66666666666667, but timer use only int
			Self.FPS = Self.CurFPS;
			Self.CurFPS = 0;
			Self.FPSTimer = 0;
		}
		//**
		Self.Step();
		//**
		_cur_time = new Date();
		Self.StepTime = _cur_time.getTime() - Self.GlobalTime;
		//**
		if (Self.IsLoop === true) {
			RequestAnimFrame(Self.Loop);
		}
	}
	
	Self.EndLoop = function () {
		Self.IsLoop = false;
	}
	
	//**
	Self.SetFullScreenEvent = function (_mge_fullscreen_proc) {
		if (typeof document.onfullscreenchange === "object") {
			document.onfullscreenchange = _mge_fullscreen_proc;
		} else {
			if (typeof document.onmozfullscreenchange === "object") {
				document.onmozfullscreenchange = _mge_fullscreen_proc;
			} else {
				if (typeof document.onwebkitfullscreenchange === "object") {
					document.onwebkitfullscreenchange = _mge_fullscreen_proc;
				} else { return false; }
			}
		}
		return true;
	}
	
	Self.SetFullScreen = function (_mge_element, _mge_enable) {
		if (_mge_enable === true) {
			if (_mge_element.requestFullScreen) {
				Self.FullScreen = true;
				_mge_element.requestFullScreen();
			} else {
				if (_mge_element.webkitRequestFullScreen) {
					Self.FullScreen = true;
					_mge_element.webkitRequestFullScreen();
				} else {
					if (_mge_element.mozRequestFullScreen) {
						Self.FullScreen = true;
						_mge_element.mozRequestFullScreen();
					} else {
						if (_mge_element.ieRequestFullScreen) {
							Self.FullScreen = true;
							_mge_element.ieRequestFullScreen();
						} else { return false; }
					}
				}
			}
		} else {
			if (document.cancelFullscreen) {
				Self.FullScreen = false;
				document.cancelFullscreen();
			} else {
				if (document.webkitCancelFullScreen) {
					Self.FullScreen = false;
					document.webkitCancelFullScreen();
				} else {
					if (document.mozCancelFullScreen) {
						Self.FullScreen = false;
						document.mozCancelFullScreen();
					} else {
						if (document.ieCancelFullScreen) {
							Self.FullScreen = false;
							document.ieCancelFullScreen();
						} else { return false; }
					}
				}
			}
		}
	}
	
	//**
	Self.Clear = function () {
		Self.IsLoop = true;
		//**
		Self.FPS = 0;
		Self.CurFPS = 0;
		Self.FPSTimer = 0;
		//**
		Self.CurTime = 0;
		Self.StepTime = 0;
		Self.FrameTime = 0;
		Self.StartTime = 0;
		Self.GlobalTime = 0;
		//**
		Self.FullScreen = false;
		//**
		Self.Step = function () {  }
	}
	
	Self.Free = function () {
		//
	}
	
}