// Make-Games.ru [Constructor, ]
// Ver 0.0.1

function MGEImageManager() {
	var Self = this;
	
	Self.ImageCount = 0;
	Self.Images = [];
	Self.ImageLoadCount = 0;
	Self.ImageLoadCur = 0;
	Self.ProcImageEvent = function (_mge_current, _mge_count) {  }

	//**
	Self._ImageLoadEvent = function () {
		Self.ImageLoadCur += 1;
		Self.ProcImageEvent(Self.ImageLoadCur, Self.ImageLoadCount);
		if (Self.ImageLoadCur >= Self.ImageLoadCount) { 
			Self.ImageLoadCur = 0;
			Self.ImageLoadCount = 0;
		}
	}

	Self.SetLoadCount = function (_mge_image_count, _mge_image_user_event) {
		Self.ImageLoadCount = _mge_image_count;
		Self.ProcImageEvent = _mge_image_user_event;
		Self.ImageLoadCur = 0;
	}

	Self.Load = function (_mge_image_path) {
		Self.Images[Self.ImageCount] = new Image();
		Self.Images[Self.ImageCount].src = _mge_image_path;
		Self.Images[Self.ImageCount].onload = Self._ImageLoadEvent;
		Self.ImageCount += 1;
		return Self.ImageCount;
	}

	Self.GetImage = function (_mge_image_id) {
		return Self.Images[_mge_image_id - 1];
	}

	//**
	Self.Clear = function () {
		Self.ImageCount = 0;
		//+USE_NEW_ARRAY+//Self.Images = [];
		//+USE_LENGTH+//Self.Images.length = 0;
		Self.ImageLoadCount = 0;
		Self.ImageLoadCur = 0;
		Self.ProcImageEvent = function (_mge_current, _mge_count) {  }
	}
	
	//**
	Self.Free = function () {
		Self.Images = null;
	}

}



















