// Make-Games.ru [Constructor, ]
// Ver 0.0.1

function MGEInformation() {
	var Self = this;
	
	//** not for cocoonJS
	Self.AudioElement = null;
	Self.VideoElement = null;
	
	Self.BrowserName = null;
	Self.BrowserVersion = null;
	
	Self.SupportAudioElement = null;
	Self.SupportMP3Format = null;
	Self.SupportOGGFormat = null;
	Self.SupportWAVFormat = null;
	Self.SupportAACFormat = null;
	
	Self.SupportVideoElement = null;
	Self.SupportWebMFormat = null;
	Self.SupportH264Format = null;
	Self.SupportTheoraFormat = null;
	
	Self.Update = function () {
		//** not for cocoonJS
		Self.BrowserName = navigator.appName;
		Self.BrowserVersion = navigator.appVersion;
		
		Self.AudioElement = document.createElement('audio');
		Self.SupportAudioElement = Self.AudioElement !== null;
		if (Self.SupportAudioElement === true && Self.AudioElement.canPlayType) {
			Self.SupportMP3Format = Self.AudioElement.canPlayType("audio/mpeg") !== "";
			Self.SupportOGGFormat = Self.AudioElement.canPlayType("audio/ogg") !== "";
			Self.SupportWAVFormat = Self.AudioElement.canPlayType("audio/wav") !== "";
			Self.SupportAACFormat = Self.AudioElement.canPlayType("audio/mp4") !== "";
		}
		
		Self.VideoElement = document.createElement('video');
		Self.SupportVideoElement = Self.VideoElement !== null;
		if (Self.SupportVideoElement === true && Self.VideoElement.canPlayType) {
			Self.SupportWebMFormat = Self.VideoElement.canPlayType("video/webm") !== "";
			Self.SupportH264Format = Self.VideoElement.canPlayType("video/mp4") !== "";
			Self.SupportTheoraFormat = Self.VideoElement.canPlayType("video/ogg") !== "";
		}

	}
	
}



















