// Make-Games.ru [Constructor, ]
// Ver 0.0.1

var CurCamera = null;

function MGECamera() {
	var Self = this;
	
	//**
	Self.Position = [0.0, 0.0];
	Self.Size = [0.0, 0.0];
	
	//**
	Self.MinVector = [0.0, 0.0];
	Self.MaxVector = [0.0, 0.0];
	
	//**
	Self.Renderer = null;
	
	//**
	Self.Initialize = function (_mge_position, _mge_size) {
		Self.Position[0] = _mge_position[0];
		Self.Position[1] = _mge_position[1];
		Self.Size[0] = _mge_size[0];
		Self.Size[1] = _mge_size[1];
		Self.MinVector[0] = _mge_position[0];
		Self.MinVector[1] = _mge_position[1];
		Self.MaxVector[0] = _mge_position[0] + _mge_size[0];
		Self.MaxVector[1] = _mge_position[1] + _mge_size[1];
	}
	
	Self.SetPosition = function () {
		Self.Position[0] = _mge_position[0];
		Self.Position[1] = _mge_position[1];
		Self.MinVector[0] = _mge_position[0];
		Self.MinVector[1] = _mge_position[1];
		Self.MaxVector[0] = _mge_position[0] + _mge_size[0];
		Self.MaxVector[1] = _mge_position[1] + _mge_size[1];
	}
	
	Self.SetSize = function () {
		Self.Size[0] = _mge_size[0];
		Self.Size[1] = _mge_size[1];
		Self.MinVector[0] = _mge_position[0];
		Self.MinVector[1] = _mge_position[1];
		Self.MaxVector[0] = _mge_position[0] + _mge_size[0];
		Self.MaxVector[1] = _mge_position[1] + _mge_size[1];
	}
	
	//**
	Self.SetActive = function (_mge_renderer) {
		Self.Renderer = _mge_renderer;
		/*if (CurCamera !== null) {
			Self.Renderer.Translate(-CurCamera.Position[0], -CurCamera.Position[1]);
		}*/
		Self.Renderer.Context.setTransform(1, 0, 0, 1, -Self.Position[0], -Self.Position[1]);
		//Self.Renderer.Translate(-Self.Position[0], -Self.Position[1]);
		CurCamera = Self;
		return true;
	}
	
	//**
	Self.Clear = function () {
		Self.Position[0] = 0;
		Self.Position[1] = 0;
		Self.Size[0] = 0;
		Self.Size[1] = 0;
		Self.MinVector[0] = 0;
		Self.MinVector[1] = 0;
		Self.MaxVector[0] = 0;
		Self.MaxVector[1] = 0;
		Self.Renderer = null;
	}
	
	Self.Free = function () {
		Self.Position = null;
		Self.Size = null;
		Self.MinVector = null;
		Self.MaxVector = null;
		Self.Renderer = null;
	}
}